clc
clear all
close all
m1_lin=load('Averaged_fields_1a20_pump2_probe1_250msdelay_linear_sample_01_wLG=7.mat');
m1_12=load('Averaged_fields_1a20_pump2_probe1_250msdelay_175mW_12mW_sample_01_wLG=7.mat');
m1_9=load('Averaged_fields_1a20_pump2_probe1_250msdelay_175mW_9mW_sample_01_wLG=7.mat');

mm1_lin=load('Averaged_fields_1a20_pump2_probem1_250msdelay_linear_sample_01_wLG=7.mat');
mm1_12=load('Averaged_fields_1a20_pump2_probem1_250msdelay_175mW_12mW_sample_01_wLG=7.mat');
mm1_9=load('Averaged_fields_1a20_pump2_probem1_250msdelay_175mW_9mW_sample_01_wLG=7.mat');

m4_lin=load('Averaged_fields_1a20_pump2_probe4_250msdelay_linear_sample_01_wLG=7.mat');
m4_12=load('Averaged_fields_1a20_pump2_probe4_250msdelay_175mW_12mW_sample_01_wLG=7.mat');
m4_9=load('Averaged_fields_1a20_pump2_probe4_250msdelay_175mW_9mW_sample_01_wLG=7.mat');

m3_lin=load('Averaged_fields_1a20_pump2_probe3_250msdelay_linear_sample_01_wLG=7.mat');
m3_12=load('Averaged_fields_1a20_pump2_probe3_250msdelay_175mW_12mW_sample_01_wLG=7.mat');
m3_9=load('Averaged_fields_1a20_pump2_probe3_250msdelay_175mW_9mW_sample_01_wLG=7.mat');

[Nx,Nt] = size(m1_12.av_recEs); 
dr=3.375; %um

x = linspace(-400,400,801).*dr;
y = linspace(-400,400,801).*dr;
[X,Y] = meshgrid(x,y);
[theta,r] = cart2pol(X,Y);


%%
figure('Position',[50 50 800 400])
sgtitle('Pump OAM = 2, P_{pu}=174mW, P_{signal}=12 mW')
subplot(2,4,5),imagesc(x,y,m4_12.av_recEi)
title('idler OAM 0')
xlim([-500 500])
ylim([-500 500])
axis square
subplot(2,4,1),imagesc(x,y,m4_12.av_recEs)
xlim([-500 500])
ylim([-500 500])
title('signal OAM 4')
axis square
subplot(2,4,6),imagesc(x,y,m3_12.av_recEi)
xlim([-500 500])
ylim([-500 500])
title('idler OAM 1')
axis square
subplot(2,4,2),imagesc(x,y,m3_12.av_recEs)
xlim([-500 500])
ylim([-500 500])
title('signal OAM 3')
axis square
subplot(2,4,7),imagesc(x,y,m1_12.av_recEi)
xlim([-500 500])
ylim([-500 500])
title('idler OAM 3')
axis square
subplot(2,4,3),imagesc(x,y,m1_12.av_recEs)
xlim([-500 500])
ylim([-500 500])
title('signal OAM 1')
axis square
subplot(2,4,8),imagesc(x,y,mm1_12.av_recEi)
xlim([-500 500])
ylim([-500 500])
title('idler OAM 5')
axis square
subplot(2,4,4),imagesc(x,y,mm1_12.av_recEs)
xlim([-500 500])
ylim([-500 500])
title('signal OAM -1')
axis square



%% ergoregion 
r_ergo = 104; % um

%% calculate reflectivity (small window)
mask = (Y).^2 ...
    + (X ).^2 <= r_ergo.^2;

%% m=3
Rm4_9 = dr.^2 .*sum(sum((1-mask).*(abs(m4_9.av_recEs).^2-abs(m4_9.av_recEi).^2)));
Nm4_9 = dr.^2 .*sum(sum((abs(m4_9.av_recEs).^2-abs(m4_9.av_recEi).^2)));
REFLm4_9= Rm4_9/Nm4_9

Rm4_12 = dr.^2 .*sum(sum((1-mask).*(abs(m4_12.av_recEs).^2-abs(m4_12.av_recEi).^2)));
Nm4_12 = dr.^2 .*sum(sum((abs(m4_12.av_recEs).^2-abs(m4_12.av_recEi).^2)));
REFLm4_12= Rm4_12/Nm4_12
%% m=2
Rm3_9 = dr.^2 .*sum(sum((1-mask).*(abs(m3_9.av_recEs).^2-abs(m3_9.av_recEi).^2)));
Nm3_9 = dr.^2 .*sum(sum((abs(m3_9.av_recEs).^2-abs(m3_9.av_recEi).^2)));
REFLm3_9= Rm3_9/Nm3_9

Rm3_12 = dr.^2 .*sum(sum((1-mask).*(abs(m3_12.av_recEs).^2-abs(m3_12.av_recEi).^2)));
Nm3_12 = dr.^2 .*sum(sum((abs(m3_12.av_recEs).^2-abs(m3_12.av_recEi).^2)));
REFLm3_12= Rm3_12/Nm3_12
%% m=-1
Rm1_9 = dr.^2 .*sum(sum((1-mask).*(abs(m1_9.av_recEs).^2-abs(m1_9.av_recEi).^2)));
Nm1_9 = dr.^2 .*sum(sum((abs(m1_9.av_recEs).^2-abs(m1_9.av_recEi).^2)));
REFLm1_9= Rm1_9/Nm1_9

Rm1_12 = dr.^2 .*sum(sum((1-mask).*(abs(m1_12.av_recEs).^2-abs(m1_12.av_recEi).^2)));
Nm1_12 = dr.^2 .*sum(sum((abs(m1_12.av_recEs).^2-abs(m1_12.av_recEi).^2)));
REFLm1_12= Rm1_12/Nm1_12
%% m=-2
Rmm1_9 = dr.^2 .*sum(sum((1-mask).*(abs(mm1_9.av_recEs).^2-abs(mm1_9.av_recEi).^2)));
Nmm1_9 = dr.^2 .*sum(sum((abs(mm1_9.av_recEs).^2-abs(mm1_9.av_recEi).^2)));
REFLmm1_9= Rmm1_9/Nmm1_9

Rmm1_12 = dr.^2 .*sum(sum((1-mask).*(abs(mm1_12.av_recEs).^2-abs(mm1_12.av_recEi).^2)));
Nmm1_12 = dr.^2 .*sum(sum((abs(mm1_12.av_recEs).^2-abs(mm1_12.av_recEi).^2)));
REFLmm1_12= Rmm1_12/Nmm1_12

OAM2 = [4,3,1,-1]-2;
REFL_9= [REFLm4_9,REFLm3_9,REFLm1_9,REFLmm1_9];
REFL_12= [REFLm4_12,REFLm3_12,REFLm1_12,REFLmm1_12];
one = ones(4);
figure
plot(OAM2,REFL_9,'d',OAM2,REFL_12,'o', OAM2, one, 'Linewidth',2)
xlabel('n-L')
ylabel('Reflectivity R(z)/N(z)')
legend('P_s = 9mW','P_s = 12mW','Location','northwest')
title('OAM pump L=2, OAM signal n=(4,3,1,-1)')
set(gca, 'FontSize',16)
saveas(gcf,'reflection_comparison_pump2_probe4_3_1_m1.png')
saveas(gcf,'reflection_comparison_pump2_probe4_3_1_m1.fig')
r=linspace(1,402,402).*dr; %um

%% current plots

figure
subplot(223)
plot(r,m1_lin.av_J0(floor(Nt/2),floor(Nx/2):Nx)./max(m1_lin.av_J0(floor(Nt/2),floor(Nx/2):Nx)),'LineWidth',2)
hold on
plot(r,m1_9.av_J0(floor(Nt/2),floor(Nx/2):Nx)./max(m1_9.av_J0(floor(Nt/2),floor(Nx/2):Nx)),'LineWidth',2)
plot(r,m1_12.av_J0(floor(Nt/2),floor(Nx/2):Nx)./max(m1_12.av_J0(floor(Nt/2),floor(Nx/2):Nx)),'LineWidth',2)
xlabel('r (\mum)')
ylabel('J_0')
title('pump 2, signal 1, idler 3')
legend('linear','9mW','12mW')

subplot(224)
plot(r,mm1_lin.av_J0(floor(Nt/2),floor(Nx/2):Nx)./max(mm1_lin.av_J0(floor(Nt/2),floor(Nx/2):Nx)),'LineWidth',2)
hold on
plot(r,mm1_9.av_J0(floor(Nt/2),floor(Nx/2):Nx)./max(mm1_9.av_J0(floor(Nt/2),floor(Nx/2):Nx)),'LineWidth',2)
plot(r,mm1_12.av_J0(floor(Nt/2),floor(Nx/2):Nx)./max(mm1_12.av_J0(floor(Nt/2),floor(Nx/2):Nx)),'LineWidth',2)
xlabel('r (\mum)')
ylabel('J_0')
title('pump 2, signal -1, idler 5')
legend('linear','9mW','12mW')

subplot(221)
plot(r,m4_lin.av_J0(floor(Nt/2),floor(Nx/2):Nx)./max(m4_lin.av_J0(floor(Nt/2),floor(Nx/2):Nx)),'LineWidth',2)
hold on
plot(r,m4_9.av_J0(floor(Nt/2),floor(Nx/2):Nx)./max(m4_9.av_J0(floor(Nt/2),floor(Nx/2):Nx)),'LineWidth',2)
plot(r,m4_12.av_J0(floor(Nt/2),floor(Nx/2):Nx)./max(m4_12.av_J0(floor(Nt/2),floor(Nx/2):Nx)),'LineWidth',2)
xlabel('r (\mum)')
ylabel('J_0')
title('pump 2, signal 4, idler 0')
legend('linear','9mW','12mW')

subplot(222)
plot(r,m3_lin.av_J0(floor(Nt/2),floor(Nx/2):Nx)./max(m3_lin.av_J0(floor(Nt/2),floor(Nx/2):Nx)),'LineWidth',2)
hold on
plot(r,m3_9.av_J0(floor(Nt/2),floor(Nx/2):Nx)./max(m3_9.av_J0(floor(Nt/2),floor(Nx/2):Nx)),'LineWidth',2)
plot(r,m3_12.av_J0(floor(Nt/2),floor(Nx/2):Nx)./max(m3_12.av_J0(floor(Nt/2),floor(Nx/2):Nx)),'LineWidth',2)
xlabel('r (\mum)')
ylabel('J_0')
title('pump 2, signal 3, idler 1')
legend('linear','9mW','12mW')

saveas(gcf,'currents_comparison_pump2_probe4_3_1_m1.png')
saveas(gcf,'currents_comparison_pump2_probe3_2_1_m1.fig')


